"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.createRegisterForeignContractIx = exports.createInitializeIx = exports.distributeUpgradeRewardsV1Ix = exports.initializeUpgradeRewardsV0Ix = exports.getCompleteTransferWrappedWithPayloadCpiAccounts = exports.createReceiveRndrV2Ix = exports.receiveRenderOutOfBoundV0Ix = void 0;
const web3_js_1 = require("@solana/web3.js");
const solana_1 = require("@certusone/wormhole-sdk/lib/cjs/solana");
const wormhole_1 = require("@certusone/wormhole-sdk/lib/cjs/solana/wormhole");
const spl_token_1 = require("@solana/spl-token");
const wormhole_sdk_1 = require("@certusone/wormhole-sdk");
const tokenBridge_1 = require("@certusone/wormhole-sdk/lib/cjs/solana/tokenBridge");
const pdas_1 = require("./pdas");
const bn_js_1 = __importDefault(require("bn.js"));
const spl_utils_1 = require("@render-foundation/spl-utils");
const emission_distributor_sdk_1 = require("@render-foundation/emission-distributor-sdk");
const circuit_breaker_sdk_1 = require("@render-foundation/circuit-breaker-sdk");
function receiveRenderOutOfBoundV0Ix(program, payer, tokenBridgeProgramId, wormholeProgramId, wormholeMessage, accts) {
    const parsed = (0, wormhole_sdk_1.isBytes)(wormholeMessage)
        ? (0, wormhole_sdk_1.parseTokenTransferVaa)(wormholeMessage)
        : wormholeMessage;
    const wrappedMint = (0, tokenBridge_1.deriveWrappedMintKey)(tokenBridgeProgramId, parsed.tokenChain, parsed.tokenAddress);
    const tokenBridgeAccounts = getCompleteTransferWrappedWithPayloadCpiAccounts(tokenBridgeProgramId, wormholeProgramId, payer, parsed);
    const recipient = new web3_js_1.PublicKey(parsed.tokenTransferPayload.subarray(2, 34));
    console.log(`recipientbar ${recipient}`);
    return program.methods
        .receiveRenderOutOfBandV0({ vaaHash: [...parsed.hash] })
        .accounts(Object.assign({ config: (0, pdas_1.redeemerConfigKey)(program.programId)[0], foreignContract: (0, pdas_1.foreignContractKey)(parsed.emitterChain)[0], recipient, transfer: (0, pdas_1.transferOutOfBandV0Key)(parsed.hash)[0], rndrMint: accts.rndrMint, circuitBreaker: accts.circuitBreakerK, bridge: accts.bridgeK, payerTokenAccount: (0, spl_token_1.getAssociatedTokenAddressSync)(wrappedMint, new web3_js_1.PublicKey(payer)), tokenBridgeProgram: new web3_js_1.PublicKey(tokenBridgeProgramId), wrndrMint: tokenBridgeAccounts.tokenBridgeWrappedMint }, tokenBridgeAccounts))
        .instruction();
}
exports.receiveRenderOutOfBoundV0Ix = receiveRenderOutOfBoundV0Ix;
function createReceiveRndrV2Ix(program, payer, tokenBridgeProgramId, wormholeProgramId, wormholeMessage, accts) {
    const parsed = (0, wormhole_sdk_1.isBytes)(wormholeMessage)
        ? (0, wormhole_sdk_1.parseTokenTransferVaa)(wormholeMessage)
        : wormholeMessage;
    const wrappedMint = (0, tokenBridge_1.deriveWrappedMintKey)(tokenBridgeProgramId, parsed.tokenChain, parsed.tokenAddress);
    const tokenBridgeAccounts = getCompleteTransferWrappedWithPayloadCpiAccounts(tokenBridgeProgramId, wormholeProgramId, payer, parsed);
    const recipient = new web3_js_1.PublicKey(parsed.tokenTransferPayload.subarray(1, 33));
    /*const recipientTokenAccount = getAssociatedTokenAddressSync(
      accts.rndrMint,
      recipient
    )*/
    return program.methods
        .receiveRenderV2({ vaaHash: [...parsed.hash] })
        .accounts(Object.assign({ config: (0, pdas_1.redeemerConfigKey)(program.programId)[0], foreignContract: (0, pdas_1.foreignContractKey)(parsed.emitterChain)[0], recipient, transfer: (0, pdas_1.transferV2Key)(parsed.hash)[0], rndrMint: accts.rndrMint, circuitBreaker: accts.circuitBreakerK, bridge: accts.bridgeK, payerTokenAccount: (0, spl_token_1.getAssociatedTokenAddressSync)(wrappedMint, new web3_js_1.PublicKey(payer)), tokenBridgeProgram: new web3_js_1.PublicKey(tokenBridgeProgramId), wrndrMint: tokenBridgeAccounts.tokenBridgeWrappedMint }, tokenBridgeAccounts))
        .instruction();
}
exports.createReceiveRndrV2Ix = createReceiveRndrV2Ix;
// Temporary
function getCompleteTransferWrappedWithPayloadCpiAccounts(tokenBridgeProgramId, wormholeProgramId, payer, vaa) {
    const parsed = (0, wormhole_sdk_1.isBytes)(vaa) ? (0, wormhole_sdk_1.parseTokenTransferVaa)(vaa) : vaa;
    const mint = (0, tokenBridge_1.deriveWrappedMintKey)(tokenBridgeProgramId, parsed.tokenChain, parsed.tokenAddress);
    const cpiProgramId = new web3_js_1.PublicKey(parsed.to);
    return {
        payer: new web3_js_1.PublicKey(payer),
        tokenBridgeConfig: (0, tokenBridge_1.deriveTokenBridgeConfigKey)(tokenBridgeProgramId),
        vaa: (0, wormhole_1.derivePostedVaaKey)(wormholeProgramId, parsed.hash),
        tokenBridgeClaim: (0, wormhole_1.deriveClaimKey)(tokenBridgeProgramId, parsed.emitterAddress, parsed.emitterChain, parsed.sequence),
        tokenBridgeForeignEndpoint: (0, tokenBridge_1.deriveEndpointKey)(tokenBridgeProgramId, parsed.emitterChain, parsed.emitterAddress),
        tokenBridgeRedeemer: (0, tokenBridge_1.deriveRedeemerAccountKey)(cpiProgramId),
        tokenBridgeWrappedMint: mint,
        tokenBridgeWrappedMeta: (0, tokenBridge_1.deriveWrappedMetaKey)(tokenBridgeProgramId, mint),
        tokenBridgeMintAuthority: (0, tokenBridge_1.deriveMintAuthorityKey)(tokenBridgeProgramId),
        rent: web3_js_1.SYSVAR_RENT_PUBKEY,
        systemProgram: web3_js_1.SystemProgram.programId,
        tokenProgram: spl_token_1.TOKEN_PROGRAM_ID,
        wormholeProgram: new web3_js_1.PublicKey(wormholeProgramId),
    };
}
exports.getCompleteTransferWrappedWithPayloadCpiAccounts = getCompleteTransferWrappedWithPayloadCpiAccounts;
const initializeUpgradeRewardsV0Ix = (program, rndrMint, args, accts) => {
    var _a;
    return program.methods
        .initializeUpgradeRewardsV0({
        authority: args.authority,
        backfillAuthority: (_a = args.backfillAuthority) !== null && _a !== void 0 ? _a : args.authority,
        upgradesEscrowConfig: args.upgradesEscrowConfig,
    })
        .accounts({
        rndrMint: rndrMint,
        rndrMintBreaker: (0, circuit_breaker_sdk_1.mintWindowedBreakerKey)(rndrMint)[0],
        upgradeRewardsEscrow: (0, pdas_1.upgradeRewardsEscrow)(rndrMint)[0],
        authority: accts.authority,
    })
        .instruction();
};
exports.initializeUpgradeRewardsV0Ix = initializeUpgradeRewardsV0Ix;
const distributeUpgradeRewardsV1Ix = (program, epochId, rndrMint, accts) => {
    const { recipient, payer } = accts;
    return program.methods
        .distributeUpgradeRewardsV1({
        epochId: new bn_js_1.default(epochId),
    })
        .accounts({
        recipient,
        upgradePoints: (0, pdas_1.upgradePointsKey)(recipient, epochId)[0],
        totalPoints: (0, pdas_1.totalUpgradePointsKey)(epochId)[0],
        aggUserUpgradePoints: (0, pdas_1.aggUserUpgradePointsKey)(recipient)[0],
        rndrMint,
        //emissionSchedule: emissionScheduleKey(rndrMint.address)[0],
        emissionScheduleReceipt: (0, emission_distributor_sdk_1.emissionScheduleReceiptKey)(rndrMint, epochId)[0],
        associatedTokenProgram: spl_token_1.ASSOCIATED_TOKEN_PROGRAM_ID,
        payer,
    })
        .instruction();
};
exports.distributeUpgradeRewardsV1Ix = distributeUpgradeRewardsV1Ix;
function createInitializeIx(program, tokenBridgeProgramId, wormholeProgramId, accts, args) {
    const { owner, wRndrMint, rndrMint, bridgeK, circuitBreakerK } = accts;
    const tokenBridgeAccounts = (0, solana_1.getTokenBridgeDerivedAccounts)(program.programId, tokenBridgeProgramId, wormholeProgramId);
    return program.methods
        .initializeBridgeV1(Object.assign(Object.assign({}, args), { incentiveThreshold: (0, spl_utils_1.toBN)(args.incentiveThreshold, rndrMint.decimals) }))
        .accounts(Object.assign({ owner: owner, bridge: (0, pdas_1.bridgeKey)(rndrMint.address, wRndrMint, program.programId)[0], rndrMint: rndrMint.address, wrndrMint: wRndrMint, circuitBreaker: circuitBreakerK, redeemerConfig: (0, pdas_1.redeemerConfigKey)(program.programId)[0], tokenBridgeProgram: new web3_js_1.PublicKey(tokenBridgeProgramId), wormholeProgram: new web3_js_1.PublicKey(wormholeProgramId) }, tokenBridgeAccounts))
        .instruction();
}
exports.createInitializeIx = createInitializeIx;
function createRegisterForeignContractIx(program, payer, tokenBridgeProgramId, chain, contractAddress, tokenBridgeForeignAddress, rndrMint, wrndrMint) {
    return __awaiter(this, void 0, void 0, function* () {
        return program.methods
            .registerForeignContractV1({ chain, address: [...contractAddress] })
            .accounts({
            owner: new web3_js_1.PublicKey(payer),
            rndrMint,
            bridge: (0, pdas_1.bridgeKey)(rndrMint, wrndrMint)[0],
            wrndrMint,
            foreignContract: (0, pdas_1.foreignContractKey)(chain)[0],
            tokenBridgeForeignEndpoint: (0, tokenBridge_1.deriveEndpointKey)(tokenBridgeProgramId, chain, tokenBridgeForeignAddress),
            tokenBridgeProgram: new web3_js_1.PublicKey(tokenBridgeProgramId),
        })
            .instruction();
    });
}
exports.createRegisterForeignContractIx = createRegisterForeignContractIx;
//# sourceMappingURL=instructions.js.map