"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.upgradeRewardsEscrow = exports.aggUserUpgradePointsKey = exports.aggTotalUpgradePointsKey = exports.adminKey = exports.redeemerConfigKey = exports.foreignContractKey = exports.totalUpgradePointsKey = exports.upgradePointsKey = exports.transferOutOfBandV0Key = exports.transferV2Key = exports.bridgeKey = void 0;
const web3_js_1 = require("@solana/web3.js");
const constants_1 = require("./constants");
const anchor = __importStar(require("@coral-xyz/anchor"));
function bridgeKey(rndrMint, wrndrMint, programId = constants_1.PROGRAM_ID) {
    return web3_js_1.PublicKey.findProgramAddressSync([Buffer.from('bridge', 'utf-8'), rndrMint.toBuffer(), wrndrMint.toBuffer()], programId);
}
exports.bridgeKey = bridgeKey;
function transferV2Key(vaaMsg, programId = constants_1.PROGRAM_ID) {
    return web3_js_1.PublicKey.findProgramAddressSync([Buffer.from('transferv2', 'utf-8'), vaaMsg], programId);
}
exports.transferV2Key = transferV2Key;
function transferOutOfBandV0Key(vaaMsg, programId = constants_1.PROGRAM_ID) {
    return web3_js_1.PublicKey.findProgramAddressSync([Buffer.from('transfer_out_of_bound_v0', 'utf-8'), vaaMsg], programId);
}
exports.transferOutOfBandV0Key = transferOutOfBandV0Key;
function upgradePointsKey(recipient, epochId, programId = constants_1.PROGRAM_ID) {
    return web3_js_1.PublicKey.findProgramAddressSync([
        Buffer.from('upgrade_points', 'utf-8'),
        recipient.toBuffer(),
        new anchor.BN(epochId).toBuffer('le', 8),
    ], programId);
}
exports.upgradePointsKey = upgradePointsKey;
function totalUpgradePointsKey(epochId, programId = constants_1.PROGRAM_ID) {
    return web3_js_1.PublicKey.findProgramAddressSync([
        Buffer.from('total_upgrade_points', 'utf-8'),
        new anchor.BN(epochId).toBuffer('le', 8),
    ], programId);
}
exports.totalUpgradePointsKey = totalUpgradePointsKey;
function foreignContractKey(chain, programId = constants_1.PROGRAM_ID) {
    return web3_js_1.PublicKey.findProgramAddressSync([
        Buffer.from('foreign_contract'),
        (() => {
            const buf = Buffer.alloc(2);
            buf.writeUInt16LE(chain);
            return buf;
        })(),
    ], programId);
}
exports.foreignContractKey = foreignContractKey;
function redeemerConfigKey(programId = constants_1.PROGRAM_ID) {
    return web3_js_1.PublicKey.findProgramAddressSync([Buffer.from('redeemer')], programId);
}
exports.redeemerConfigKey = redeemerConfigKey;
function adminKey(programId = constants_1.PROGRAM_ID) {
    return web3_js_1.PublicKey.findProgramAddressSync([Buffer.from('admin')], programId);
}
exports.adminKey = adminKey;
function aggTotalUpgradePointsKey(programId = constants_1.PROGRAM_ID) {
    return web3_js_1.PublicKey.findProgramAddressSync([Buffer.from('agg_total_upgrade_points', 'utf-8')], programId);
}
exports.aggTotalUpgradePointsKey = aggTotalUpgradePointsKey;
function aggUserUpgradePointsKey(owner, programId = constants_1.PROGRAM_ID) {
    return web3_js_1.PublicKey.findProgramAddressSync([Buffer.from('agg_user_upgrade_points_v1', 'utf-8'), owner.toBuffer()], programId);
}
exports.aggUserUpgradePointsKey = aggUserUpgradePointsKey;
function upgradeRewardsEscrow(rndrMint, programId = constants_1.PROGRAM_ID) {
    return web3_js_1.PublicKey.findProgramAddressSync([Buffer.from('upgrade_rewards', 'utf-8'), rndrMint.toBuffer()], programId);
}
exports.upgradeRewardsEscrow = upgradeRewardsEscrow;
//# sourceMappingURL=pdas.js.map