import { Program } from '@coral-xyz/anchor';
import { PROGRAM_ID, IDL } from './constants';
import { bridgeResolvers } from './resolvers';
export * from './constants';
export * from './pdas';
export * from './instructions';
export async function init(provider, programId = PROGRAM_ID, idl) {
    // TODO: circumventing anchor upgrade idl failure so that idl can be loaded locally
    const resIdl = await (async () => {
        if (typeof idl === 'boolean') {
            return IDL;
        }
        if (!idl) {
            return await Program.fetchIdl(programId, provider);
        }
        return idl;
    })();
    // @ts-ignore
    const bridge = new Program(resIdl, programId, provider, undefined, () => bridgeResolvers);
    return bridge;
}
//# sourceMappingURL=index.js.map